version: '2'

services:

  front:
    build: front
    env_file: .env.dev
    environment:
      - "HOST=0.0.0.0"
    ports:
      - "8080:8080"
    volumes:
      - './front:/app'

  postgres:
    env_file: .env.dev
    image: postgres

  redis:
    env_file: .env.dev
    image: redis:3.0

  celeryworker:
    env_file: .env.dev
    build:
      context: ./api
      dockerfile: docker/Dockerfile.test
    links:
     - postgres
     - redis
    command: celery -A funkwhale_api.taskapp worker -l debug
    environment:
      - "DJANGO_ALLOWED_HOSTS=localhost"
      - "DJANGO_SETTINGS_MODULE=config.settings.local"
      - "DJANGO_SECRET_KEY=dev"
      - C_FORCE_ROOT=true
      - "DATABASE_URL=postgresql://postgres@postgres/postgres"
      - "CACHE_URL=redis://redis:6379/0"
      - "FUNKWHALE_URL=http://funkwhale.test"
    volumes:
      - ./api:/app
      - ./data/music:/music
  api:
    env_file: .env.dev
    build:
      context: ./api
      dockerfile: docker/Dockerfile.test
    command: python /app/manage.py runserver 0.0.0.0:12081
    volumes:
      - ./api:/app
      - ./data/music:/music
    environment:
      - "PYTHONDONTWRITEBYTECODE=true"
      - "DJANGO_ALLOWED_HOSTS=localhost,nginx"
      - "DJANGO_SETTINGS_MODULE=config.settings.local"
      - "DJANGO_SECRET_KEY=dev"
      - "DATABASE_URL=postgresql://postgres@postgres/postgres"
      - "CACHE_URL=redis://redis:6379/0"
      - "FUNKWHALE_URL=http://funkwhale.test"
    links:
      - postgres
      - redis

  nginx:
    env_file: .env.dev
    image: nginx
    links:
      - api
      - front
    volumes:
      - ./docker/nginx/conf.dev:/etc/nginx/nginx.conf
      - ./api/funkwhale_api/media:/protected/media
    ports:
      - "0.0.0.0:6001:6001"

  docs:
    build: docs
    command: python serve.py
    volumes:
      - ".:/app/"
    ports:
      - '35730:35730'
      - '8001:8001'
